VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDates"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function IsLeapYear(intYear As Integer) As Boolean
    '
    ' Check if a year is a leap year.
    '
    IsLeapYear = False
    
    If intYear Mod 4 = 0 Then
        If intYear Mod 100 = 0 Then
            If intYear Mod 400 = 0 Then
                IsLeapYear = True
            End If
        Else
            IsLeapYear = True
        End If
    End If

End Function

Public Function MonthEnd(strDate As String, _
                blnSkipCurMthEnd As Boolean) As String

'
' Convert a date in "yyyymmdd" format
' to the closest month end date.
'
Dim strYear    As String
Dim strMth     As String
Dim strDay     As String
Dim strNextDay As String

    strYear = Mid$(strDate, 1, 4)
    strMth = Mid$(strDate, 5, 2)
    '
    ' Get the current month end date.
    '
    Select Case strMth
        Case "04", "06", "09", "11"
            strDay = "30"
            
        Case "02"
            If IsLeapYear(Val(strYear)) Then
                strDay = "29"
            Else
                strDay = "28"
            End If
        
        Case Else
            strDay = "31"
    End Select
    MonthEnd = strYear & strMth & strDay
    '
    ' If the date is the month end, and the "skip current
    ' month end" flag is set, get the next month end date.
    '
    If (MonthEnd = strDate) And blnSkipCurMthEnd Then
        strNextDay = NextDay(strDate)
        MonthEnd = MonthEnd(strNextDay, False)
    End If
    
End Function



Public Function NextDay(strDate As String) As String
Dim dteDate As Date
    '
    ' Convert a date in "yyyymmdd" format to
    ' the following calendar day.
    '
    dteDate = Format(strDate, "@@@@-@@-@@")
    NextDay = Format$(DateAdd("d", 1, dteDate), "yyyymmdd")
    
End Function



Public Function QuarterEnd(strDate As String, _
            blnSkipCurQtrEnd As Boolean) As String
'
' Convert a date in "yyyymmdd" format to
' the closest quarter end date.
'
Dim strYear    As String
Dim strMth     As String
Dim strMthEnd  As String
Dim strNextDay As String
    
    strYear = Mid$(strDate, 1, 4)
    strMth = Mid$(strDate, 5, 2)
    '
    ' Get the current quarter end date.
    '
    Select Case strMth
        Case "01", "02", "03"
            strMthEnd = "0331"
            
        Case "04", "05", "06"
            strMthEnd = "0630"
            
        Case "07", "08", "09"
            strMthEnd = "0930"
            
        Case "10", "11", "12"
            strMthEnd = "1231"
    End Select
    QuarterEnd = strYear & strMthEnd
    '
    ' If the date is the quarter end, and the "skip current
    ' quarter end" flag is set, get the next quarter end date.
    '
    If (QuarterEnd = strDate) And blnSkipCurQtrEnd Then
        strNextDay = NextDay(strDate)
        QuarterEnd = QuarterEnd(strNextDay, False)
    End If
    
End Function




